
function PARAMS = V_Classification_of_o_Phys(PARAMS)

load('VMH_PAG_Cluster_centroids.mat')
Cluster_centroids = VMH_PAG_Cluster_centroids;
O_phys = PARAMS(53).value;
O_phys(isnan(O_phys)) = 0;
o_phys_z_score = zscore(O_phys,0,1);

nROIs = size(o_phys_z_score,1);
n_clusters = size(Cluster_centroids,1);

Centroid_dist_rank = zeros(nROIs,1);
Centroid_corr_rank = zeros(nROIs,1);
for i = 1:nROIs
          if i == round(nROIs*0.2)
        multiWaitbar('Classification of o-Phys...',0.2,'Color', [0.929 0.694 0.125]);
          elseif i == round(nROIs*0.4)
        multiWaitbar('Classification of o-Phys...',0.4,'Color', [0.929 0.694 0.125]);
          elseif i == round(nROIs*0.6)
        multiWaitbar('Classification of o-Phys...',0.6,'Color', [0.929 0.694 0.125]);
          elseif i == round(nROIs*0.8)
        multiWaitbar('Classification of o-Phys...',0.8,'Color', [0.929 0.694 0.125]);
          elseif i == nROIs
        multiWaitbar('Classification of o-Phys...',1,'Color', [0.929 0.694 0.125]);
          end

    Neuron = o_phys_z_score(i,:);
    distances = sqrt(sum((Cluster_centroids - Neuron).^2,2));
    Sorted = sort(distances);
    Centroid_dist_rank(i,:) = find(distances == Sorted(1));

    CORR = zeros(18,1);
    for j = 1:n_clusters
        Custer_centroid = Cluster_centroids(j,:);
        R = corrcoef(Neuron,Custer_centroid);
        CORR(j) = R(2,1);
    end
    SCORR = sort(CORR);
    Centroid_corr_rank(i,:) = find(CORR == SCORR(end));
end

PARAMS(63).name = 'Centroid_dist_rank';
PARAMS(64).name = 'Centroid_corr_rank';

PARAMS(63).value = Centroid_dist_rank;
PARAMS(64).value = Centroid_corr_rank;

end


