
function PARAMS = V_Load_and_Fill_Stack_PAR(filename)

Data = bfOpen3DVolume(filename);
Stack = Data{1,1}{1,1};

% Check for frame loss and fill it
    Mean_of_frames = squeeze(mean(Stack,[1,2]));
  if max(max(Mean_of_frames)) > 20000 % probable error point!!!!!!!!!!!!!!
    Sweep_end_idx = find(Mean_of_frames>(max(Mean_of_frames)*0.7));
    frame_loss = Sweep_end_idx(rem(Sweep_end_idx,Sweep_end_idx(1)) ~= 0);
    if isempty(frame_loss) == 0

            k = 1;
            while isempty(frame_loss) == 0
                To_append = min(frame_loss);
                if k == 1
                    % Takes the before + the last frame of the before + after
                    Stack_filled = cat(3,Stack(:,:,1:To_append-1),...
                    Stack(:,:,To_append-1), Stack(:,:,To_append:end));
                    Mean_of_frames_filled = squeeze(mean(Stack_filled,[1,2]));
                else
                    Stack_filled = cat(3,Stack_filled(:,:,1:To_append-1),...
                    Stack_filled(:,:,To_append-1), Stack_filled(:,:,To_append:end));
                    Mean_of_frames_filled = squeeze(mean(Stack_filled,[1,2]));
                end
                Sweep_end_idx = find(Mean_of_frames_filled>(max(Mean_of_frames_filled)*0.7));
                frame_loss = Sweep_end_idx(rem(Sweep_end_idx,Sweep_end_idx(1)) ~= 0); 
                k = k + 1;
            end
            Nframes_filled = size(Stack_filled,(3));
    else

    Stack_filled = Stack;
    Nframes_filled = size(Stack_filled,(3));
    Mean_of_frames_filled = Mean_of_frames;
    end
    
    % Check for missing frames in the end and fill it
        NSweeps = numel(Sweep_end_idx)+1;

        EndFill = (Sweep_end_idx(1)*NSweeps) - Nframes_filled;
        if EndFill > 0

       filling_frame = Stack_filled(:,:,end);
            for m = 1:EndFill
              Stack_filled(:,:,end+1) = filling_frame;
            end
        end
    
    % Remove Sweep-end artifacts
    Sweep_end_idx = find(Mean_of_frames_filled>(max(Mean_of_frames_filled)*0.7));

    Stack_filled(:,:,Sweep_end_idx-1) = Stack_filled(:,:,Sweep_end_idx-2);
    Stack_filled(:,:,Sweep_end_idx) = Stack_filled(:,:,Sweep_end_idx-3);
    Stack_filled(:,:,Sweep_end_idx+1) = Stack_filled(:,:,Sweep_end_idx-4);
    
    Nframes_filled = size(Stack_filled,(3));
    Sweep_L = Sweep_end_idx(1);
    NSweeps = numel(Sweep_end_idx)+1;
    
    % Store variables
    PARAMS(1).name = 'Nframes_filled';
    PARAMS(2).name = 'NSweeps';
    PARAMS(3).name = 'Sweep_L';
    PARAMS(4).name = 'Stack_filled';
    
    PARAMS(1).value = Nframes_filled;
    PARAMS(2).value = NSweeps;
    PARAMS(3).value = Sweep_L;
    PARAMS(4).value = Stack_filled;

  else

  Stack_filled = Stack;
  Nframes_filled = size(Stack,3);
  
    PARAMS(1).name = 'Nframes_filled';
    PARAMS(2).name = 'NSweeps';
    PARAMS(3).name = 'Sweep_L';
    PARAMS(4).name = 'Stack_filled';
    
    PARAMS(1).value = Nframes_filled;
    PARAMS(2).value = [];
    PARAMS(3).value = [];
    PARAMS(4).value = Stack_filled;

  end
end

  