
function PARAMS = V_O_phys_Params_OnSite(PARAMS)

    nROIs = PARAMS(16).value;
    BURST_Lengths = PARAMS(50).value;       % open ROIs_12345_BURST_Lengths
    BURST_Nums = PARAMS(49).value;          % 'ROIs_12345_BURST_Nums'
    BURST_APS_Perc = PARAMS(52).value;      % 'ROIS_APS_IN_BURST'
    BURST_Firing_Freqs = PARAMS(51).value;  % 'ROIs_12345_BURST_Firing_Freqs'
    ROI_AVG_Freq = PARAMS(46).value;        % 'ROIs_123_Avg_Freqs'
    ROIs_AP_IDXs_MoveFilt = transpose(PARAMS(36).value);
    sweep_bef = (PARAMS(22).value);
    sweep_stim = (PARAMS(23).value);
    sweep_aft = (PARAMS(24).value);
    Bluespike = (PARAMS(21).value);
    Mean_PSPs_Pos = PARAMS(60).value;
    Mean_PSPs_Neg = PARAMS(61).value;
    PairP_SubSlope = PARAMS(62).value;


    Avg_Freq_bef = zeros(1,nROIs);
    Avg_Freq_stim = zeros(1,nROIs);
    Avg_Freq_aft = zeros(1,nROIs);
    AP_num_bef = zeros(1,nROIs);
    AP_num_stim = zeros(1,nROIs);
    AP_num_aft = zeros(1,nROIs);
    AP_Percent_bef = zeros(1,nROIs);
    AP_Onset_stim = zeros(1,nROIs);
    AP_Onset_stim_L = zeros(1,nROIs);
    BIMOD_Binary = zeros(1,nROIs);
    BIMOD_Coeff = zeros(1,nROIs);
    AP_Freq_stim_H1 = zeros(1,nROIs);
    AP_Freq_stim_H2 = zeros(1,nROIs);
    AP_Freq_stim_H2_H1 = zeros(1,nROIs);
    AP_Freq_stim_Q1 = zeros(1,nROIs);
    AP_Freq_stim_Q4 = zeros(1,nROIs);
    AP_Freq_stim_Q4_Q1 = zeros(1,nROIs);
    AP_Freq_aft_H1 = zeros(1,nROIs);
    AP_Freq_aft_H2 = zeros(1,nROIs);
    AP_Freq_aft_H2_H1 = zeros(1,nROIs);
    IBI_Avg_AP_Num = zeros(1,nROIs);
    IBIs_With_APs = zeros(1,nROIs);
    Burst_length_stim = zeros(1,nROIs);
    Burst_length_stim_h1 = zeros(1,nROIs);
    Burst_length_stim_h2 = zeros(1,nROIs);
    Burst_length_stim_H2_H1 = zeros(1,nROIs);
    Burst_length_aft = zeros(1,nROIs);
    Burst_length_aft_h1 = zeros(1,nROIs);
    Burst_length_aft_h2 = zeros(1,nROIs);
    Burst_length_aft_H2_H1 = zeros(1,nROIs);
    Burst_number_stim = zeros(1,nROIs);
    Burst_number_stim_h1 = zeros(1,nROIs);
    Burst_number_stim_h2 = zeros(1,nROIs);
    Burst_number_aft = zeros(1,nROIs);
    Burst_number_aft_h1 = zeros(1,nROIs);
    Burst_number_aft_h2 = zeros(1,nROIs);
    Burst_Freqs_stim = zeros(1,nROIs);
    Burst_Freqs_aft = zeros(1,nROIs);
    Burst_Aps_perc = zeros(1,nROIs);
    PSP_pos = zeros(1,nROIs);
    PSP_neg = zeros(1,nROIs);

    O_phys = zeros(29,nROIs);
    for j = 1:nROIs
      if j == round(nROIs*0.2)
        multiWaitbar('Classification parameters...',0.2,'Color', [0.929 0.694 0.125]);
          elseif j == round(nROIs*0.4)
        multiWaitbar('Classification parameters...',0.4,'Color', [0.929 0.694 0.125]);
          elseif j == round(nROIs*0.6)
        multiWaitbar('Classification parameters...',0.6,'Color', [0.929 0.694 0.125]);
          elseif j == round(nROIs*0.8)
        multiWaitbar('Classification parameters...',0.8,'Color', [0.929 0.694 0.125]);
          elseif j == nROIs
        multiWaitbar('Classification parameters...',1,'Color', [0.929 0.694 0.125]);
      end

        AP_Idx = cell2mat(ROIs_AP_IDXs_MoveFilt(j));
        AP_bef = zeros(1,size(AP_Idx,2)); % size(AP_Idx,2) is number of sweeps
        AP_bef_percent = zeros(1,size(AP_Idx,2));
        AP_stim = zeros(1,size(AP_Idx,2));
        AP_aft = zeros(1,size(AP_Idx,2));
        AP_onset = zeros(1,size(AP_Idx,2));
        AP_Onset_L = zeros(1,size(AP_Idx,2));
        Bimod_binary = zeros(1,size(AP_Idx,2));
        Bimod_coeff = zeros(1,size(AP_Idx,2));
        AP_freq_stim_H1 = zeros(1,size(AP_Idx,2));
        AP_freq_stim_H2 = zeros(1,size(AP_Idx,2));
        AP_freq_stim_H2_H1 = zeros(1,size(AP_Idx,2));
        AP_freq_stim_Q1 = zeros(1,size(AP_Idx,2));
        AP_freq_stim_Q4 = zeros(1,size(AP_Idx,2));
        AP_freq_stim_Q4_Q1 = zeros(1,size(AP_Idx,2));   
        AP_freq_aft_H1 = zeros(1,size(AP_Idx,2));
        AP_freq_aft_H2 = zeros(1,size(AP_Idx,2));
        AP_freq_aft_H2_H1 = zeros(1,size(AP_Idx,2));
        IBI_avg_AP_num = zeros(1,size(AP_Idx,2));
        IBIs_with_APs = zeros(1,size(AP_Idx,2));
        for o = 1:size(AP_Idx,2) % sweeps
         

            sweep_APs = AP_Idx(:,o);
            idx_bef = find(sweep_APs <= max(sweep_bef));
            
            %----- Percentage of APs on first half vs second half of bef
            if isempty(idx_bef) == 1
                AP_bef_percent(:,o) = 0;
            else
                APs_bef_half1 = numel(find(sweep_APs < (max(sweep_bef)/2)));
                APs_bef_all = numel(idx_bef);
                AP_bef_percent(:,o) = (APs_bef_half1 / APs_bef_all)*100;
            end

            %----- Onset of first AP if there are any APs

            idx_stim = find(sweep_APs >= max(sweep_bef) & sweep_APs <= max(sweep_stim));
            if isempty(idx_stim) == 0
                 onset_AP = min(sweep_APs(idx_stim));
                 onset_L = (onset_AP - max(sweep_bef))*1.66; % in ms
                 AP_Onset_L(:,o) = onset_L;
                 if onset_L < 50
                    AP_onset(:,o) = 10;
                 elseif onset_L > 50 && onset_L < 100
                    AP_onset(:,o) = 9;
                 elseif onset_L > 100 && onset_L < 150
                    AP_onset(:,o) = 8;
                 elseif onset_L > 150 && onset_L < 200
                    AP_onset(:,o) = 7;
                 elseif onset_L > 200 && onset_L < 250
                    AP_onset(:,o) = 6;
                 elseif onset_L > 250 && onset_L < 300
                    AP_onset(:,o) = 5;
                 elseif onset_L > 300 && onset_L < 350
                    AP_onset(:,o) = 4;
                 elseif onset_L > 350 && onset_L < 400
                    AP_onset(:,o) = 3;
                 elseif onset_L > 400 && onset_L < 450
                    AP_onset(:,o) = 2;
                 elseif onset_L > 450 && onset_L < 500
                    AP_onset(:,o) = 1;
                 elseif onset_L > 500
                    AP_onset(:,o) = 1;
                 end
            else
                 AP_onset(:,o) = 0;
                 AP_Onset_L(:,o) = 0;
            end
            
            %----- Avg freq of APs on first and second half of stim
            if isempty(idx_stim) == 0
                length_stim = (max(sweep_stim) - min(sweep_stim));
                
                idx_stim_H1 = find(sweep_APs >= max(sweep_bef) & sweep_APs <= (max(sweep_stim)-length_stim/2));
                AP_freq_stim_h1 = (1000/((length_stim/2) * 1.66)) * numel(idx_stim_H1);
                
                idx_stim_H2 = find(sweep_APs >= (max(sweep_stim)-length_stim/2) & sweep_APs <= max(sweep_stim));
                AP_freq_stim_h2 = (1000/((length_stim/2) * 1.66)) * numel(idx_stim_H2);

                if AP_freq_stim_h1 == 0
                    AP_freq_stim_h1 = 1;
                end
                if AP_freq_stim_h2 == 0
                    AP_freq_stim_h2 = 1;
                end  
                AP_freq_stim_h2_h1 = AP_freq_stim_h2 / AP_freq_stim_h1;


                idx_stim_Q1 = find(sweep_APs >= max(sweep_bef) & sweep_APs <= (max(sweep_bef)+(round(length_stim*0.25))));
                AP_freq_stim_q1 = (1000/((length_stim/4) * 1.66)) * numel(idx_stim_Q1);
                idx_stim_Q4 = find(sweep_APs >= (max(sweep_bef)+(round(length_stim*0.75)))...
                    & sweep_APs <= (max(sweep_stim)));
                AP_freq_stim_q4 = (1000/((length_stim/4) * 1.66)) * numel(idx_stim_Q4);

                if AP_freq_stim_q1 == 0
                    AP_freq_stim_q1 = 1;
                end
                if AP_freq_stim_q4 == 0
                    AP_freq_stim_q4 = 1;
                end  
                AP_freq_stim_q4_q1 = AP_freq_stim_q4 / AP_freq_stim_q1;
            else
                AP_freq_stim_h1 = 0;
                AP_freq_stim_h2 = 0;
                AP_freq_stim_h2_h1 = 0;
                AP_freq_stim_q1 = 0;
                AP_freq_stim_q4 = 0;
                AP_freq_stim_q4_q1 = 0;

            end
            AP_freq_stim_H1(:,o) = AP_freq_stim_h1;
            AP_freq_stim_H2(:,o) = AP_freq_stim_h2;
            AP_freq_stim_H2_H1(:,o) = AP_freq_stim_h2_h1;
            
            AP_freq_stim_Q1(:,o) = AP_freq_stim_q1;
            AP_freq_stim_Q4(:,o) = AP_freq_stim_q4;
            AP_freq_stim_Q4_Q1(:,o) = AP_freq_stim_q4_q1;


            %----- Avg freq of APs on first and second half of aft            
            idx_aft = find(sweep_APs >= max(sweep_stim));
            if isempty(idx_aft) == 0
                length_aft = (max(sweep_aft) - min(sweep_aft));
                idx_aft_H1 = find(sweep_APs >= max(sweep_stim) & sweep_APs <= (max(sweep_aft)-length_aft/2));
                AP_freq_aft_h1 = (1000/((length_aft/2) * 1.66)) * numel(idx_aft_H1);
                idx_aft_H2 = find(sweep_APs >= (max(sweep_aft)-length_aft/2) & sweep_APs <= max(sweep_aft));
                AP_freq_aft_h2 = (1000/((length_aft/2) * 1.66)) * numel(idx_aft_H2);

                if AP_freq_aft_h1 == 0
                    AP_freq_aft_h1 = 1;
                end
                if AP_freq_aft_h2 == 0
                    AP_freq_aft_h2 = 1;
                end                
                AP_freq_aft_h2_h1 = AP_freq_aft_h2 / AP_freq_aft_h1;
            else
                AP_freq_aft_h1 = 0;
                AP_freq_aft_h2 = 0;
                AP_freq_aft_h2_h1 = 0;
            end
            AP_freq_aft_H1(:,o) = AP_freq_aft_h1;
            AP_freq_aft_H2(:,o) = AP_freq_aft_h2;
            AP_freq_aft_H2_H1(:,o) = AP_freq_aft_h2_h1;


            AP_bef(:,o) = numel(idx_bef);
            AP_stim(:,o) = numel(idx_stim);
            AP_aft(:,o) = numel(idx_aft); 


            %------ Avg number of APs in an IBI and Percentage of IBIs with
            % APs
            if isempty(idx_stim) == 0
                ibi_APs = zeros(1,size(Bluespike,1));
                for b = 1:numel(Bluespike)
                    IBI_s = Bluespike(b);
                    IBI_e = Bluespike(b)+30; % at 600 Hz
                    ibi_APs(b) = numel(find(sweep_APs > IBI_s & sweep_APs < IBI_e));
                end
                IBI_avg_AP_num(:,o) = mean(ibi_APs);
                IBIs_with_aps = numel(find(ibi_APs > 0));
                IBIs_with_APs(:,o) = (IBIs_with_aps / numel(Bluespike))*100;
            else
                IBI_avg_AP_num(:,o) = 0;
                IBIs_with_APs(:,o) = 0;
            end
            
            %----- Bimodality coefficient of stim APs if there are APs
            if isempty(idx_stim) == 0
                AP_ISIs = diff(sweep_APs(idx_stim));
                [BF, BC] = bimodalitycoeff(AP_ISIs);
                if sum(isnan(BF)) > 0
                    Bimod_binary(:,o) = 0;
                else
                    Bimod_binary(:,o) = BF;
                end
                if sum(isnan(BC)) > 0
                    Bimod_coeff(:,o) = 0;
                else
                    Bimod_coeff(:,o) = BC;
                end
            else
                Bimod_binary(:,o) = 0;
                Bimod_coeff(:,o) = 0;
            end  

        end
        AP_num_bef(j) = mean(AP_bef);
        AP_num_stim(j) = mean(AP_stim);
        AP_num_aft(j) = mean(AP_aft);
        AP_Percent_bef(j) = mean(AP_bef_percent);
        AP_Onset_stim(j) = (mean(AP_onset(AP_onset > 0)));
        AP_Onset_stim_L(j) = (mean(AP_Onset_L(AP_Onset_L > 0)));
        BIMOD_Binary(j) = mean(Bimod_binary);
        BIMOD_Coeff(j) = mean(Bimod_coeff);
        AP_Freq_stim_H1(j) = mean(AP_freq_stim_H1);
        AP_Freq_stim_H2(j) = mean(AP_freq_stim_H2);
        AP_Freq_stim_H2_H1(j) = mean(AP_freq_stim_H2_H1);
        AP_Freq_stim_Q1(j) = mean(AP_freq_stim_Q1);
        AP_Freq_stim_Q4(j) = mean(AP_freq_stim_Q4);
        AP_Freq_stim_Q4_Q1(j) = mean(AP_freq_stim_Q4_Q1);
        AP_Freq_aft_H1(j) = mean(AP_freq_aft_H1);
        AP_Freq_aft_H2(j) = mean(AP_freq_aft_H2);
        AP_Freq_aft_H2_H1(j) = mean(AP_freq_aft_H2_H1);
        IBI_Avg_AP_Num(j) = mean(IBI_avg_AP_num);
        IBIs_With_APs(j) = mean(IBIs_with_APs);


        %--------------------------------------------------------------
        %------ Burst Length stim H1
        burst_l = cell2mat(BURST_Lengths(j));
        burst_l_stim_h1 = burst_l(2,:);
        burst_l_stim_h1(isnan(burst_l_stim_h1)) = 0;
        
        if sum(burst_l_stim_h1 > 0) > 2 % more then 2 sweeps has burst
            burst_length_stim_h1 = mean(burst_l_stim_h1(burst_l_stim_h1>0));
            Burst_length_stim_h1(:,j) = burst_length_stim_h1;
        else
            burst_length_stim_h1 = 0;
            Burst_length_stim_h1(:,j) = 0;
        end
        
        %------ Burst Length stim H2
        burst_l_stim_h2 = burst_l(3,:);
        burst_l_stim_h2(isnan(burst_l_stim_h2)) = 0;

        if sum(burst_l_stim_h2 > 0) > 2 % more then 2 sweeps has burst
            burst_length_stim_h2 = mean(burst_l_stim_h2(burst_l_stim_h2>0));
            Burst_length_stim_h2(:,j) = burst_length_stim_h2;
        else
            burst_length_stim_h2 = 0;
            Burst_length_stim_h2(:,j) = 0;
        end

        
        %------ Burst Length aft H1
        burst_l_aft_h1 = burst_l(4,:);
        burst_l_aft_h1(isnan(burst_l_aft_h1)) = 0;

        if sum(burst_l_aft_h1 > 0) > 2 % more then 2 sweeps has burst
            burst_length_aft_h1 = mean(burst_l_aft_h1(burst_l_aft_h1>0));
            Burst_length_aft_h1(:,j) = burst_length_aft_h1;
        else
            burst_length_aft_h1 = 0;
            Burst_length_aft_h1(:,j) = 0;
        end
        
        %------ Burst Length aft H2
        burst_l_aft_h2 = burst_l(5,:);
        burst_l_aft_h2(isnan(burst_l_aft_h2)) = 0;

        if sum(burst_l_aft_h2 > 0) > 2 % more then 2 sweeps has burst
            burst_length_aft_h2 = mean(burst_l_aft_h2(burst_l_aft_h2>0));
            Burst_length_aft_h2(:,j) = burst_length_aft_h2;
        else
            burst_length_aft_h2 = 0;
            Burst_length_aft_h2(:,j) = 0;
        end


        if isempty(idx_stim) == 0 % yes APs -> yes bursts
                if burst_length_stim_h1 == 0
                    burst_length_stim_h1 = 1;
                end
                if burst_length_stim_h2 == 0
                    burst_length_stim_h2 = 1;
                end
                Burst_length_stim_h2_h1 = burst_length_stim_h2 / burst_length_stim_h1;
                
                if burst_length_aft_h1 == 0
                    burst_length_aft_h1 = 1;
                end
                if burst_length_aft_h2 == 0
                    burst_length_aft_h2 = 1;
                end
                Burst_length_aft_h2_h1 = burst_length_aft_h2 / burst_length_aft_h1;
        else % no APs -> no bursts
                Burst_length_stim_h2_h1 = 0;
                Burst_length_aft_h2_h1 = 0;
        end
            Burst_length_stim_H2_H1(:,j) = Burst_length_stim_h2_h1;
            Burst_length_aft_H2_H1(:,j) = Burst_length_aft_h2_h1;



        %------ Burst Length stim
        burst_l_stim = burst_l(2:3,:);
        burst_l_stim(isnan(burst_l_stim)) = 0;
        burst_l_stim_sum = sum(burst_l_stim,1);

        if sum(burst_l_stim_sum > 0) > 2 % more then 2 sweeps has burst
            Burst_length_stim(:,j) = mean(burst_l_stim_sum);
        else
            Burst_length_stim(:,j) = 0;
        end
        %------ Burst Length aft
        burst_l_aft = burst_l(4:5,:);
        burst_l_aft(isnan(burst_l_aft)) = 0;
        burst_l_aft_sum = sum(burst_l_aft,1);

        if sum(burst_l_aft_sum > 0) > 2 % more then 2 sweeps has burst
            Burst_length_aft(:,j) = mean(burst_l_aft_sum);
        else
            Burst_length_aft(:,j) = 0;
        end
        %------------------------------------------------------------
        %------ Burst Num stim H1
        burst_n = cell2mat(BURST_Nums(j));
        burst_n_stim_h1 = burst_n(2,:);
        burst_n_stim_h1(isnan(burst_n_stim_h1)) = 0;

        if sum(burst_n_stim_h1 > 0) > 2 % more then 2 sweeps has burst
            Burst_number_stim_h1(:,j) = mean(burst_n_stim_h1(burst_n_stim_h1>0));
        else
            Burst_number_stim_h1(:,j) = 0;
        end

        %------ Burst Num stim H2
        burst_n_stim_h2 = burst_n(3,:);
        burst_n_stim_h2(isnan(burst_n_stim_h2)) = 0;

        if sum(burst_n_stim_h2 > 0) > 2 % more then 2 sweeps has burst
            Burst_number_stim_h2(:,j) = mean(burst_n_stim_h2(burst_n_stim_h2>0));
        else
            Burst_number_stim_h2(:,j) = 0;
        end

        %------ Burst Num aft H1 
        burst_n_aft_h1 = burst_n(4,:);
        burst_n_aft_h1(isnan(burst_n_aft_h1)) = 0;

        if sum(burst_n_aft_h1 > 0) > 2 % more then 2 sweeps has burst
            Burst_number_aft_h1(:,j) = mean(burst_n_aft_h1(burst_n_aft_h1>0));
        else
            Burst_number_aft_h1(:,j) = 0;
        end
        
        %------ Burst Num aft H2
        burst_n_aft_h2 = burst_n(5,:);
        burst_n_aft_h2(isnan(burst_n_aft_h2)) = 0;

        if sum(burst_n_aft_h2 > 0) > 2 % more then 2 sweeps has burst
            Burst_number_aft_h2(:,j) = mean(burst_n_aft_h2(burst_n_aft_h2>0));
        else
            Burst_number_aft_h2(:,j) = 0;
        end

        %------ Burst Num stim
        burst_n_stim = burst_n(2:3,:);
        burst_n_stim(isnan(burst_n_stim)) = 0;
        burst_n_stim_sum = sum(burst_n_stim,1);

        if sum(burst_n_stim_sum > 0) > 2 % more then 2 sweeps has burst
            Burst_number_stim(:,j) = mean(burst_n_stim_sum);
        else
            Burst_number_stim(:,j) = 0;
        end
        
        %------ Burst Num aft
        burst_n_aft = burst_n(4:5,:);
        burst_n_aft(isnan(burst_n_aft)) = 0;
        burst_n_aft_sum = sum(burst_n_aft,1);

        if sum(burst_n_aft_sum > 0) > 2 % more then 2 sweeps has burst
            Burst_number_aft(:,j) = mean(burst_n_aft_sum);
        else
            Burst_number_aft(:,j) = 0;
        end

        %------------------------------------------------------------


        burst_freq = cell2mat(BURST_Firing_Freqs(j));
        burst_freq_stim = burst_freq(2:3,:);
        burst_freq_stim(isnan(burst_freq_stim)) = 0;
        burst_freq_stim_sum = sum(burst_freq_stim,1);

        if sum(burst_freq_stim_sum > 0) > 2 % more then 2 sweeps has burst
            Burst_Freqs_stim(:,j) = mean(burst_freq_stim_sum(burst_freq_stim_sum>0));
        else
            Burst_Freqs_stim(:,j) = 0;
        end

        burst_freq_aft = burst_freq(4:5,:);
        burst_freq_aft(isnan(burst_freq_aft)) = 0;
        burst_freq_aft_sum = sum(burst_freq_aft,1);

        if sum(burst_freq_aft_sum > 0) > 2 % more then 2 sweeps has burst
            Burst_Freqs_aft(:,j) = mean(burst_freq_aft_sum(burst_freq_aft_sum>0));
        else
            Burst_Freqs_aft(:,j) = 0;
        end


        burst_aps_perc = cell2mat(BURST_APS_Perc);
        perc = burst_aps_perc(j,:);
        nonzero = numel(perc(perc > 0));
        if nonzero > 2 % more then 2 sweeps has burst
            Burst_Aps_perc(:,j) = mean(perc(perc>0));
        else
            Burst_Aps_perc(:,j) = 0;
        end


        Avg_Freq = cell2mat(ROI_AVG_Freq{j,:});
        freq_bef = Avg_Freq(1,:);
        if sum(~isnan(freq_bef)) > 3 % at least 3 sweeps has APs
            freq_bef_avg = mean(freq_bef(~isnan(freq_bef)));
        else
            freq_bef_avg = 0;
        end
        Avg_Freq_bef(j) = freq_bef_avg;


        freq_stim = Avg_Freq(2,:);
        if sum(~isnan(freq_stim)) > 3
            freq_stim_avg = mean(freq_stim(~isnan(freq_stim)));
        else
            freq_stim_avg = 0;
        end
        Avg_Freq_stim(j) = freq_stim_avg;


        freq_aft = Avg_Freq(3,:);
        if sum(~isnan(freq_aft)) > 3
            freq_aft_avg = mean(freq_aft(~isnan(freq_aft)));
        else
            freq_aft_avg = 0;
        end
        Avg_Freq_aft(j) = freq_aft_avg;



        Psp_Pos = cell2mat(Mean_PSPs_Pos(j,:));
        Psp_Pos_edges = find(diff(sign(Psp_Pos)));
        Psp_Pos_onset_edges = Psp_Pos_edges(Psp_Pos(Psp_Pos_edges) == 0);
        PsP_Pos_num = numel(Psp_Pos_onset_edges);
        PSP_pos(j) = PsP_Pos_num;
    
        Psp_Neg = cell2mat(Mean_PSPs_Neg(j,:));
        Psp_Neg_edges = find(diff(sign(Psp_Neg)));
        Psp_Neg_onset_edges = Psp_Neg_edges(Psp_Neg(Psp_Neg_edges) == 0);
        PsP_Neg_num = numel(Psp_Neg_onset_edges);
        PSP_neg(j) = PsP_Neg_num; 

    end

    PP1 = PairP_SubSlope(1,:);
    PP1(PP1 < 0.5) = 0.5;
    PP1(PP1 > 1.5) = 1.5;

    PP2 = PairP_SubSlope(2,:);
    PP2(PP2 < 0.5) = 0.5;
    PP2(PP2 > 1.5) = 1.5;

    SSlope_21 = PairP_SubSlope(3,:);
    SSlope_21(SSlope_21 < -0.004) = -0.004;
    SSlope_21(SSlope_21 > 0.004) = 0.004;

    SSlope_all = PairP_SubSlope(4,:);
    SSlope_all(SSlope_all < -0.004) = -0.004;
    SSlope_all(SSlope_all > 0.004) = 0.004;
%------------------------------------------------------------------



perc_out = 100 - Burst_Aps_perc;
perc_out(perc_out == 100) = 0;

O_phys(1,:) = Avg_Freq_bef;
O_phys(2,:) = AP_num_bef;
O_phys(3,:) = PSP_pos;
O_phys(4,:) = PSP_neg;
O_phys(5,:) = PP1;
O_phys(6,:) = PP2;
O_phys(7,:) = SSlope_21;
O_phys(8,:) = SSlope_all;
O_phys(9,:) = Burst_Freqs_stim; % CHECK
O_phys(10,:) = Burst_Freqs_aft; % CHECK
O_phys(11,:) = Burst_Aps_perc;
O_phys(12,:) = perc_out;
O_phys(13,:) = AP_Onset_stim;
O_phys(14,:) = AP_Freq_stim_H1;
O_phys(15,:) = AP_Freq_stim_H2;
O_phys(16,:) = AP_Freq_stim_H2_H1;
O_phys(17,:) = AP_Freq_aft_H1;
O_phys(18,:) = AP_Freq_aft_H2;
O_phys(19,:) = AP_Freq_aft_H2_H1;
O_phys(20,:) = BIMOD_Binary;
O_phys(21,:) = BIMOD_Coeff;
O_phys(22,:) = Burst_length_stim_h1;
O_phys(23,:) = Burst_length_stim_h2;
O_phys(24,:) = Burst_length_aft_h1;
O_phys(25,:) = Burst_length_aft_h2;
O_phys(26,:) = Burst_number_stim_h1;
O_phys(27,:) = Burst_number_stim_h2;
O_phys(28,:) = Burst_number_aft_h1;
O_phys(29,:) = Burst_number_aft_h2;

O_phys = transpose(O_phys);

PARAMS(53).name = 'O_phys';

PARAMS(53).value = O_phys;

end


