
function PARAMS = V_ROI_AP_RawDen_PAR(PARAMS)

ROI_fullTraces_raw = PARAMS(14).value;
ROI_fullTraces_den_Sym2 = PARAMS(15).value;
nROIs = PARAMS(16).value;
NSweeps = PARAMS(2).value;
Sweep_L = PARAMS(3).value;

Raw_sweeps = reshape(ROI_fullTraces_raw,Sweep_L,nROIs*NSweeps);
Raw_sweeps(1,:) = Raw_sweeps(3,:); % remove the potential big value in point 1
Raw_sweeps(2,:) = Raw_sweeps(4,:); % make sure to remove the big value in point 1

% WRITE THIS TO CALCULATE FOR EACH INDIVIDUAL CELL!
Avg_sweep = mean(Raw_sweeps,2);
Avg_sweep_based = Avg_sweep - mean(Avg_sweep);
Avg_sweep_based = highpass(Avg_sweep_based,5,600);
BlueSpike = V_APdet_noplot_blue(Avg_sweep_based,0.3);


for j = 1:numel(BlueSpike)
    blue = BlueSpike(j);
    fill_blue = mean(Raw_sweeps(blue-5:blue-2,:));
    Raw_sweeps(blue,:) = fill_blue;
    fill_blue_bef = mean(Raw_sweeps(blue-5:blue-3,:));
    Raw_sweeps(blue-1,:) = fill_blue_bef;
    fill_blue_aft = mean(Raw_sweeps(blue-4:blue-2,:));
    Raw_sweeps(blue+1,:) = fill_blue_aft;
end

sweep_bef = (1:min(BlueSpike)-3)';
sweep_stim = (min(BlueSpike)-2:max(BlueSpike)+30)';
sweep_aft = ((max(BlueSpike)+31):Sweep_L)';


% Fit and dFF with poly4 for AP detection----------------------------------
Raw_sweeps_bef = Raw_sweeps(sweep_bef,:); 
warning('off');
 Raw_bef_dff = zeros(size(Raw_sweeps_bef));
 X_f_b = (1:size(Raw_sweeps_bef,1))';
 for i = 1:nROIs*NSweeps
    raw_sweep = Raw_sweeps_bef(:,i);
    y = raw_sweep(X_f_b);
    f = fit(X_f_b,y,'poly4');
    fit_values = f(X_f_b);
    raw_sweep_fit = raw_sweep - fit_values;
    raw_sweep_dff = raw_sweep_fit./fit_values;
    Raw_bef_dff(:,i) = raw_sweep_dff*-1;
 end   
 multiWaitbar('AP detection...',0.2,'Color', [0.929 0.694 0.125]);

 Raw_sweeps_stim = Raw_sweeps(sweep_stim,:);
 warning('off');   
 Raw_stim_dff = zeros(size(Raw_sweeps_stim));
 X_f_s = (1:size(Raw_sweeps_stim,1))';
 for i = 1:nROIs*NSweeps
    raw_sweep = Raw_sweeps_stim(:,i);
    y = raw_sweep(X_f_s);
    f = fit(X_f_s,y,'poly4');
    fit_values = f(X_f_s);
    raw_sweep_fit = raw_sweep - fit_values;
    raw_sweep_dff = raw_sweep_fit./fit_values;
    Raw_stim_dff(:,i) = raw_sweep_dff*-1;
 end
 multiWaitbar('AP detection...',0.4,'Color', [0.929 0.694 0.125]);

 Raw_sweeps_aft = Raw_sweeps(sweep_aft,:);
 warning('off');
 Raw_aft_dff = zeros(size(Raw_sweeps_aft));
 X_f_a = (1:size(Raw_sweeps_aft,1))';
 for i = 1:nROIs*NSweeps
    raw_sweep = Raw_sweeps_aft(:,i);
    y = raw_sweep(X_f_a);
    f = fit(X_f_a,y,'poly4');
    fit_values = f(X_f_a);
    raw_sweep_fit = raw_sweep - fit_values;
    raw_sweep_dff = raw_sweep_fit./fit_values;
    Raw_aft_dff(:,i) = raw_sweep_dff*-1;
 end
 multiWaitbar('AP detection...',0.6,'Color', [0.929 0.694 0.125]);

Raw_sweeps_dff_poly4 = [Raw_bef_dff; Raw_stim_dff; Raw_aft_dff];
Raw_fullTraces_dff_poly4 = reshape(Raw_sweeps_dff_poly4,size(ROI_fullTraces_raw,1),...
    size(ROI_fullTraces_raw,2));

ROIs_fullTraces_DenRaw = zeros(size(ROI_fullTraces_raw));
ROIs_AP_IDXs = cell(nROIs,1);
ROIs_AP_Vals = cell(nROIs,1);
ROIs_APs_Thr = zeros(nROIs,1);
%Raw_sweeps_dff_poly4_p = parallel.pool.Constant(Raw_sweeps_dff_poly4);
  for i = 1:nROIs
          if i == round(nROIs*0.8)
        multiWaitbar('AP detection...',0.8,'Color', [0.929 0.694 0.125]);
          elseif i == nROIs
        multiWaitbar('AP detection...',1,'Color', [0.929 0.694 0.125]);
          end

        roi_co1_idx = ((i*NSweeps+1) - NSweeps : i*NSweeps);
        ROI_sweeps_dff = Raw_sweeps_dff_poly4(:,roi_co1_idx); %Raw_sweeps_dff_poly4_p.Value
        base = ROI_sweeps_dff(sweep_bef,:);
        base_neg = base(base<0);
        STD = std(abs(base_neg));
        Thr = STD*5; % 2xSTD added to the trace
        ROIs_APs_Thr(i,:) = Thr;
        ROI_sweeps_dff_b = ROI_sweeps_dff - Thr;
        
        % detect APs on the bef,stim,aft poly4 fitted, threshold-baselined whole sweeps
        ROI_aps = cell(1,NSweeps);
        ROI_vals = cell(1,NSweeps);
        for j = 1:NSweeps
        sweep = ROI_sweeps_dff(:,j);
        sweep_b = ROI_sweeps_dff_b(:,j); % Thr is subtracted, only APs are positive going
        sweep_b_aps = V_APdet_noplot_trace(sweep_b);
            if numel(sweep_b_aps) < 2
              noAPs(1:Sweep_L,:) = NaN;
              ROI_aps{1,j} = noAPs;
              ROI_vals{1,j} = noAPs;
            else
              Ap_vals = sweep(sweep_b_aps);
              ROI_vals{1,j} = Ap_vals;
              sweep_b_aps_pad = padarray(sweep_b_aps,Sweep_L-length(sweep_b_aps),NaN,'post');
              ROI_aps{1,j} = sweep_b_aps_pad;
            end
          ROIs_AP_IDXs{i} = ROI_aps;
          ROIs_AP_Vals{i} = ROI_vals;
        end
        
        % use the threshold to compose suprathreshold Raw + subthreshold
        % wavelet-denoised traces
        Roi_fullTrace_dff_raw = Raw_fullTraces_dff_poly4(:,i);
        Below_Thr = find(Roi_fullTrace_dff_raw < Thr);
        
        Roi_fullTrace_den = ROI_fullTraces_den_Sym2(:,i);
        Roi_fulltrace_denraw = ROI_fullTraces_raw(:,i);
        Roi_fulltrace_denraw(Below_Thr,:) = Roi_fullTrace_den(Below_Thr,:); %Roi_fullTrace_den
        ROIs_fullTraces_DenRaw(:,i) = Roi_fulltrace_denraw;
  end
        %fprintf('%s\n','...AP detection Done...');


  PARAMS(20).name = 'Raw_sweeps';
  PARAMS(21).name = 'BlueSpike';
  PARAMS(22).name = 'sweep_bef';
  PARAMS(23).name = 'sweep_stim';
  PARAMS(24).name = 'sweep_aft';
  PARAMS(25).name = 'Raw_sweeps_dff_poly4';
  PARAMS(26).name = 'Raw_fullTraces_dff_poly4';
  PARAMS(27).name = 'ROIs_AP_IDXs';
  PARAMS(28).name = 'ROIs_AP_Vals';
  PARAMS(29).name = 'ROIs_APs_Thr';
  PARAMS(30).name = 'ROIs_fullTraces_DenRaw';

  PARAMS(20).value = Raw_sweeps;
  PARAMS(21).value = BlueSpike;
  PARAMS(22).value = sweep_bef;
  PARAMS(23).value = sweep_stim;
  PARAMS(24).value = sweep_aft;
  PARAMS(25).value = Raw_sweeps_dff_poly4;
  PARAMS(26).value = Raw_fullTraces_dff_poly4;
  PARAMS(27).value = ROIs_AP_IDXs;
  PARAMS(28).value = ROIs_AP_Vals;
  PARAMS(29).value = ROIs_APs_Thr;
  PARAMS(30).value = ROIs_fullTraces_DenRaw;
  
end


