
function PARAMS = V_ROI_Shift_and_Trace_Extraction(PARAMS,c,s,discard_sweep)

if c < 10 
  datafile1 = ['Data0000' num2str(c)];
elseif c > 9 && c < 100
  datafile1 = ['Data000' num2str(c)];
elseif c > 99
  datafile1 = ['Data00' num2str(c)];
end

if s < 10 
  datafile2 = ['Data0000' num2str(s)];
elseif s > 9 && s < 100
  datafile2 = ['Data000' num2str(s)];
elseif s > 99
  datafile2 = ['Data00' num2str(s)];
end

filename1 = [datafile1 '.mat'];
C_PAR = struct2cell(load(filename1));
C_PAR = C_PAR{1};

Contour_coords_video_1 = C_PAR(17).value;
Center = C_PAR(19).value;           % center coords
nROIs = C_PAR(16).value;
Video1 = C_PAR(10).value;           % Ieq16 of Video1

NSweeps = PARAMS(2).value;         % only necessary if a sweep is deleted
Sweep_L = PARAMS(3).value;         % only necessary if a sweep is deleted
Nframes_filled = PARAMS(1).value;   % Nframes_filled of Video2
Stack_filled = PARAMS(4).value;     % filled_stack of Video2
Video2 = PARAMS(10).value;          % Ieq16 of Video2
[rows,cols] = find(Video2);         % coordinates of all points
All_point_coords = [rows cols];

Contour_coords_video_2 = cell(1,nROIs);
SHIFT = cell(1,nROIs);
ROIs_shift_track = zeros(nROIs,1);
    q = figure;
    if size(Video1,2) < 300
    set(q,'units','normalized','outerposition',[ 0 0 0.5 1 ]);
    else
    set(q,'units','normalized','outerposition',[ 0 0 1 1 ]);
    end
    ax1 = subplot(211);
    imagesc(Video1); colormap gray; title(datafile1); hold on

   for i = 1:nROIs
    Cont = cell2mat(Contour_coords_video_1(i)); nans = isnan(Cont(:,1));
    Cont(nans,:) = [];
    y_cont = Cont(:,1);
    x_cont = Cont(:,2);
    contour = [x_cont y_cont];
    scatter(y_cont,x_cont,4,'c','filled'); hold on

    Cent = cell2mat(Center(1,i));
    cent_y = Cent(:,1);
    cent_x = Cent(:,2);
    Text = num2str(i);
    text(cent_y, cent_x, Text,'Color','c','FontSize',10,'FontWeight','bold');
    hold on

    idx_patch_around = knnsearch(All_point_coords,contour,'K',3500);
    % size of patch area can filter ROIs which moved too much to be in the
    % range of the patch
    Idx_Patch_around = unique(idx_patch_around);
    x_patch = rows(Idx_Patch_around);
    y_patch = cols(Idx_Patch_around);
    
    x_patch_min = min(x_patch);
    x_patch_max = max(x_patch);
    x_patch_side = x_patch_max - x_patch_min;
    y_patch_min = min(y_patch);
    y_patch_max = max(y_patch);
    y_patch_side = y_patch_max - y_patch_min;
    POS = [y_patch_min x_patch_min y_patch_side x_patch_side];
    Video1_crop = imcrop(Video1, POS);
    
    rectangle('Position',[y_patch_min x_patch_min y_patch_side x_patch_side],...
        'EdgeColor','w','LineWidth',0.25); hold on
    
    correlationOutput = normxcorr2(Video1_crop, Video2);
    [maxCorrValue, maxIndex] = max(abs(correlationOutput(:)));
    [ypeak, xpeak] = ind2sub(size(correlationOutput),maxIndex(1));
    corr_offset = [(xpeak-size(Video1_crop,2)+1) (ypeak-size(Video1_crop,1)+1)];

    X_Shift = x_patch_min - corr_offset(2);
    Y_Shift = y_patch_min - corr_offset(1);
    shift = [corr_offset(2) corr_offset(1)];
    SHIFT{i} = shift;
    Size_Video2 = size(Video2);
      if abs(X_Shift) < x_patch_side && abs(Y_Shift) < y_patch_side
        x_fix = x_cont - X_Shift;
        x_fix(x_fix < 1) = 1;
        x_fix(x_fix > Size_Video2(1)) = Size_Video2(1);
        y_fix = y_cont - Y_Shift;
        y_fix(y_fix < 1) = 1;
        y_fix(y_fix > Size_Video2(2)) = Size_Video2(2);
        
        warning('off');
        in = inpolygon(rows,cols,x_cont,y_cont);    % find pixels inside original contour
        idx_roi = find(in(:));
        in_fix = inpolygon(rows,cols,x_fix,y_fix);  % find pixels inside fixed contour
        idx_roi_fix = find(in_fix(:));
           if numel(idx_roi_fix) >= numel(idx_roi)*0.7
             x_fix_pad = padarray(x_fix,2000-length(x_fix),NaN,'post');
             y_fix_pad = padarray(y_fix,2000-length(y_fix),NaN,'post');
             Contour_coords_video_2{i} = [y_fix_pad x_fix_pad];
          else
             x_fix_pad(1:2000,:) = NaN;
             y_fix_pad(1:2000,:) = NaN;
             Contour_coords_video_2{i} = [y_fix_pad x_fix_pad];
             ROIs_shift_track(i) = 1;
          end
      else
         x_fix_pad(1:2000,:) = NaN;
         y_fix_pad(1:2000,:) = NaN;
         Contour_coords_video_2{i} = [y_fix_pad x_fix_pad];
         ROIs_shift_track(i) = 1;
      end
   end
   
   multiWaitbar('ROI Shift and Trace Extraction...',0.4,'Color', [0.929 0.694 0.125]);

   ax2 = subplot(212); % The script is 2 loops because of ax2
   imagesc(Video2); colormap gray; title(datafile2); hold on
 for i = 1:nROIs
    Cont = cell2mat(Contour_coords_video_1(i)); nans = isnan(Cont(:,1));
    Cont(nans,:) = [];
    y_cont = Cont(:,1);
    x_cont = Cont(:,2);
    scatter(y_cont,x_cont,2,'c','filled'); hold on

    Cont_fix = cell2mat(Contour_coords_video_2(i)); nans = isnan(Cont_fix(:,1));
    Cont_fix(nans,:) = [];
    y_fix = Cont_fix(:,1);
    x_fix = Cont_fix(:,2);
    
    if isempty(y_fix) == 1
      scatter(y_cont,x_cont,6,'r','filled'); hold on % if contour is not fixed
    else
      scatter(y_fix,x_fix,4,[1 0.83 0],'filled'); hold on % if shift is detected and fixed
    end
 end
 linkaxes([ax1,ax2],'xy');

    multiWaitbar('ROI Shift and Trace Extraction...',0.6,'Color', [0.929 0.694 0.125]);


   ROIs_Contour_coords = Contour_coords_video_2; % rename it here for PARAMS storage
   ROIs_Roi_center_coords = cell(1,nROIs);
   ROIs_Roi_coords = cell(1,nROIs);
   ROI_fullTraces_raw = zeros(Nframes_filled,nROIs);
   ROI_fullTraces_den_Sym2 = zeros(Nframes_filled,nROIs);
   Outlines = zeros(Size_Video2);
   for i = 1:nROIs
        Cont_fix = cell2mat(ROIs_Contour_coords(i)); nans = isnan(Cont_fix(:,1));
        Cont_fix(nans,:) = [];
        if isempty(Cont_fix) == 1 % if ROI was lost
            x_nodata(1:2000,:) = NaN;
            y_nodata(1:2000,:) = NaN;
            ROIs_Roi_center_coords{i} = [y_nodata x_nodata];
            ROIs_Roi_coords{i} = [y_nodata x_nodata];
            NaN_trace(1:Nframes_filled) = NaN;
            ROI_fullTraces_raw(:,i) = NaN_trace;
            ROI_fullTraces_den_Sym2(:,i) = NaN_trace;
            continue
        else
        y_cont = Cont_fix(:,1);
        x_cont = Cont_fix(:,2);

        idx_cont = sub2ind(Size_Video2,x_cont,y_cont);
        Outlines(idx_cont) = i;

        Cent_x = round(mean(x_cont))-3; % -3 pixel for the ROI number
        Cent_y = round(mean(y_cont));
        ROIs_Roi_center_coords{i} = [Cent_x Cent_y];

        in_fix = inpolygon(rows,cols,x_cont,y_cont); % find pixels inside fixed contour
        idx_roi_fix = find(in_fix(:));
        x_roi = cols(idx_roi_fix);
        y_roi = rows(idx_roi_fix);
        x_roi_pad = padarray(x_roi,2000-length(x_roi),NaN,'post');
        y_roi_pad = padarray(y_roi,2000-length(y_roi),NaN,'post');
        ROIs_Roi_coords{i} = [x_roi_pad y_roi_pad];
        
       % Raw trace extraction
        npixel = numel(x_roi);
        trace_Roi_pixels = zeros(1,npixel,Nframes_filled);
            for j = 1:npixel
                x = x_roi(j,:);
                y = y_roi(j,:);
                trace_Roi_pixels(1,j,:) = Stack_filled(y,x,:);
            end
        Trace_ROI = squeeze(mean(trace_Roi_pixels,[1 2]));

        ROI_fullTraces_raw(:,i) = Trace_ROI;
        Trace_ROI_den = wdenoise(Trace_ROI,2,Wavelet='sym2',DenoisingMethod='Bayes');
        ROI_fullTraces_den_Sym2(:,i) = Trace_ROI_den;  
        end
   end

    ROI_fullTraces_raw(:,ROIs_shift_track == 1) = 0;
    ROI_fullTraces_den_Sym2(:,ROIs_shift_track == 1) = 0;


     if discard_sweep > 0
        ROI_sweeps_raw = reshape(ROI_fullTraces_raw,Sweep_L,NSweeps*nROIs);
        ROI_sweeps_raw(:,discard_sweep:NSweeps:end) = [];
        NSweeps = NSweeps-1;
        PARAMS(2).value = NSweeps;
        ROI_fullTraces_raw = reshape(ROI_sweeps_raw,Sweep_L*NSweeps,nROIs);
        ROI_fullTraces_den_Sym2 = zeros(Sweep_L*NSweeps,nROIs);
    
        for i = 1:nROIs
            trace = ROI_fullTraces_raw(:,i);
            Trace_ROI_den = wdenoise(trace,2,Wavelet='sym2',DenoisingMethod='Bayes');
            ROI_fullTraces_den_Sym2(:,i) = Trace_ROI_den;
        end 
     end

    multiWaitbar('ROI Shift and Trace Extraction...',1,'Color', [0.929 0.694 0.125]);

    %nROIs = nROIs - sum(ROIs_shift_track); % nROIs is the number of non-lost ROIs

    PARAMS(13).name = 'ROIs_shift_track';
    PARAMS(14).name = 'ROI_fullTraces_raw';
    PARAMS(15).name = 'ROI_fullTraces_den_Sym2';
    PARAMS(16).name = 'nROIs';
    PARAMS(17).name = 'ROIs_Contour_coords';
    PARAMS(18).name = 'ROIs_Roi_coords';
    PARAMS(19).name = 'ROIs_Roi_center_coords';

    PARAMS(13).value = ROIs_shift_track;
    PARAMS(14).value = ROI_fullTraces_raw;
    PARAMS(15).value = ROI_fullTraces_den_Sym2;
    PARAMS(16).value = nROIs;
    PARAMS(17).value = ROIs_Contour_coords;
    PARAMS(18).value = ROIs_Roi_coords;
    PARAMS(19).value = ROIs_Roi_center_coords;

    PARAMS(4).name = [];
    PARAMS(4).value = [];  

    close

end


