
function V_ROI_Zoom_S(~,~, ax, pos, pos0, FovImage, ROIs_Contour_coords,...
    ROIs_center_coords,O_Phys_Change,Param_Comp,cutoff)

global Param_Comp

    if get(ax,'Position') == pos0
        ax.Position = pos;
        axes(ax)

        Tag = get(gca,'tag');
        T = str2double(Tag);
        Cont_current = cell2mat(ROIs_Contour_coords(T));
        X_cur = Cont_current(:,1); X_cur(isnan(X_cur)) = [];
        Y_cur = Cont_current(:,2); Y_cur(isnan(Y_cur)) = [];
  


    figure(1);
    g = subaxis(6,5,[1,2,3,6,7,8],'Spacing',0.02);
    axes(g);
    imagesc(FovImage);
    colormap gray;
    axis image;

        
    hold on

    for i = 1:size(ROIs_Contour_coords,2) 
        Cont = cell2mat(transpose(ROIs_Contour_coords(i)));
        cent = cell2mat(ROIs_center_coords(i));
        X = Cont(:,1); X(isnan(X)) = [];
        Y = Cont(:,2); Y(isnan(Y)) = [];
            if isempty(Param_Comp) == 1
                Color = [0.8 0.8 0.8];
            else
                Param = O_Phys_Change(:,Param_Comp);
                if Param(i) > 100 + cutoff
                    Color = [1 0 0]; % red
                elseif Param(i) < 100 - cutoff
                    Color = [0 0 1]; % blue
                else
                    Color = [0.8 0.8 0.8];
                end
        
            end   
        scatter(X,Y,3,Color,'filled');
        Text = num2str(i);
        text(cent(2), cent(1), Text,'Color','c','FontSize',9); % 'FontWeight','bold'
        hold on
    end
    
    hold on
    scatter(X_cur,Y_cur,5,'c','filled');
    Text = Tag;
    text(cent(2), cent(1), Text,'Color','c','FontSize',10);

    g.BoxStyle = 'full';
    g.XColor = [0.9290 0.6940 0.1250];
    g.YColor = [0.9290 0.6940 0.1250];
    g.XTick = [];
    g.YTick = [];
    hold off

    else
        ax.Position = pos0;
        axes(ax) % enlarge axes to explore
    end
    
end

