
function PARAMS = V_SUB_Parameters_OnSite(PARAMS)

    sweep_bef =  PARAMS(22).value;
    sweep_stim = PARAMS(23).value;
    BlueSpike = PARAMS(21).value;
    NSweeps = PARAMS(2).value;
    Sweep_L = PARAMS(3).value;
    nROIs = PARAMS(16).value;
    ROIs_sweeps_DenRaw_dff_move_10 = PARAMS(32).value;
    DenRaw_sweeps_dff_poly2 = PARAMS(34).value;


    ROIs_Stim_Binary_PSPs_Pos = cell(nROIs,1);
    ROIs_Stim_Binary_PSPs_Neg = cell(nROIs,1);
    ROIs_Mean_Binary_PSPs_Pos = cell(nROIs,1);
    ROIs_Mean_Binary_PSPs_Neg = cell(nROIs,1);
    ROIs_Mean_sweep_dff_poly2 = cell(nROIs,1);
    ROIs_Mean_sweep_move_10 = cell(nROIs,1);
    PairP_SubSlope = zeros(6,nROIs);
    for j = 1:nROIs
              if j == round(nROIs*0.2)
        multiWaitbar('Mean Trace o-PSPs...',0.2,'Color', [0.929 0.694 0.125]);
          elseif j == round(nROIs*0.4)
        multiWaitbar('Mean Trace o-PSPs...',0.4,'Color', [0.929 0.694 0.125]);
          elseif j == round(nROIs*0.6)
        multiWaitbar('Mean Trace o-PSPs...',0.6,'Color', [0.929 0.694 0.125]);
          elseif j == round(nROIs*0.8)
        multiWaitbar('Mean Trace o-PSPs...',0.8,'Color', [0.929 0.694 0.125]);
          elseif j == nROIs
        multiWaitbar('Mean Trace o-PSPs...',1,'Color', [0.929 0.694 0.125]);
              end

        roi_co1_idx = ((j*NSweeps+1)-NSweeps : j*NSweeps);
        ROI_sweeps_dff_move_10 = ROIs_sweeps_DenRaw_dff_move_10(:,roi_co1_idx);
        
        Mean_trace = mean(ROI_sweeps_dff_move_10,2);
        ROI_sweeps_dff_poly2 = DenRaw_sweeps_dff_poly2(:,roi_co1_idx);
        Mean_sweep_dff_poly2 = mean(ROI_sweeps_dff_poly2,2);

        IBI1 = Mean_trace(BlueSpike(1):BlueSpike(2));
        IBI2 = Mean_trace(BlueSpike(2):BlueSpike(3));
        IBI3 = Mean_trace(BlueSpike(3):BlueSpike(4));
        IBI_2_1 = max(IBI2) / max(IBI1);
        IBI_3_2 = max(IBI3) / max(IBI2);
        PairP_SubSlope(1,j) = IBI_2_1;
        PairP_SubSlope(2,j) = IBI_3_2;

        Mean_stim = Mean_trace(sweep_stim);
        l_stim = numel(Mean_stim);
        q1 = mean(Mean_stim(1:round(l_stim*0.25)));
        q2 = mean(Mean_stim(round(l_stim*0.25):round(l_stim*0.5)));
        q3 = mean(Mean_stim(round(l_stim*0.5):round(l_stim*0.75)));
        q4 = mean(Mean_stim(round(l_stim*0.75):l_stim));
        Q1_2 = [q1 q2];
        x1_2 = [1 2];
        Q1_4 = [q1 q2 q3 q4];
        x1_4 = [1 2 3 4];

        P_1 = polyfit(x1_2,Q1_2,1); % yfit = P_1(1) * x1_2 + P_1(2);
        P_all = polyfit(x1_4,Q1_4,1); % yfit = P_all(1) * x1_4 + P_all(2);

        PairP_SubSlope(3,j) = P_1(1);
        PairP_SubSlope(4,j) = P_all(1);

        PairP_SubSlope(5,j) = numel(find(Mean_stim < 0));
        PairP_SubSlope(6,j) = numel(find(Mean_stim > 0));

        Base_10 = Mean_trace(sweep_bef,:);
        base_neg_10 = Base_10(Base_10 < 0);
        STD_10 = std(abs(base_neg_10));
        Thr_10_pos = STD_10*8;
        Thr_10_neg = Thr_10_pos*-1;
        Thr_10_pos_mean = STD_10*3;
        Thr_10_neg_mean = (Thr_10_pos_mean*3)*-1;

        if isempty(Mean_trace(~isnan(Mean_trace))) == 1
        Mean_trace(1:Sweep_L,:) = 0;
        end
        Mean_PSP_binary_Pos = V_Binary_Sum_PSP_Pos(Mean_trace,Thr_10_pos_mean,BlueSpike);       
        Mean_PSP_binary_Neg = V_Binary_Sum_PSP_Neg(Mean_trace,Thr_10_neg_mean,BlueSpike);       

        ROI_Stim_psps_pos = zeros(Sweep_L,NSweeps);
        ROI_Stim_psps_neg = zeros(Sweep_L,NSweeps);
        for k = 1:NSweeps
            sweep_move_10 = ROI_sweeps_dff_move_10(:,k);
            if isempty(sweep_move_10(~isnan(sweep_move_10))) == 1
                Mean_PSP_binary_Pos(1:Sweep_L,:) = 0;
                Mean_PSP_binary_Neg(1:Sweep_L,:) = 0;
                continue
            end
          % fill the sweeps PSP_pos and PSP_neg with the mean to save time
            ROI_Stim_psps_pos(:,k) = Mean_PSP_binary_Pos;
            ROI_Stim_psps_neg(:,k) = Mean_PSP_binary_Neg;     
        end

    ROIs_Stim_Binary_PSPs_Pos{j} = ROI_Stim_psps_pos;
    ROIs_Stim_Binary_PSPs_Neg{j} = ROI_Stim_psps_neg;
    ROIs_Mean_Binary_PSPs_Pos{j} = Mean_PSP_binary_Pos;
    ROIs_Mean_Binary_PSPs_Neg{j} = Mean_PSP_binary_Neg;
    ROIs_Mean_sweep_dff_poly2{j} = Mean_sweep_dff_poly2;
    ROIs_Mean_sweep_move_10{j} = Mean_trace;
    end


    PARAMS(56).name = 'ROIs_Stim_Binary_PSPs_Pos';
    PARAMS(57).name = 'ROIs_Stim_Binary_PSPs_Neg';
    PARAMS(58).name = 'ROIs_Mean_sweep_dff_poly2';
    PARAMS(59).name = 'ROIs_Mean_sweep_move_10';
    PARAMS(60).name = 'ROIs_Mean_Binary_PSPs_Pos';
    PARAMS(61).name = 'ROIs_Mean_Binary_PSPs_Neg';
    PARAMS(62).name = 'PairP_SubSlope';
    
        
    PARAMS(56).value = ROIs_Stim_Binary_PSPs_Pos;
    PARAMS(57).value = ROIs_Stim_Binary_PSPs_Neg;
    PARAMS(58).value = ROIs_Mean_sweep_dff_poly2;
    PARAMS(59).value = ROIs_Mean_sweep_move_10;
    PARAMS(60).value = ROIs_Mean_Binary_PSPs_Pos;
    PARAMS(61).value = ROIs_Mean_Binary_PSPs_Neg;
    PARAMS(62).value = PairP_SubSlope;

end

