
function PARAMS = V_Segment_and_ROI_Trace_Extraction_PAR(PARAMS,SomaDiam,manual_ROI,discard_sweep)
    
    Ieq32 = PARAMS(11).value;
    pyrun('img = np.array(mat_image)', mat_image = Ieq32);
    pyrun('masks, flows, styles, diams = model.eval(img, diameter=dia, channels=[0,0])',dia=SomaDiam);
    py_outlines = pyrun('outlines = masks*cellpose.utils.masks_to_outlines(masks)', ...
                        'outlines');
    Outlines = uint16(py_outlines);

%%
multiWaitbar('Segmentation,Trace Extraction...',0.3,'Color', [0.929 0.694 0.125]);

[rows,cols] = find(Ieq32);
nROIs_outlines = max(max(Outlines));
ROIs_Contour_coords = cell(1,nROIs_outlines);
for i = 1:nROIs_outlines
    cont = find(Outlines == i);
    x_cont = cols(cont);
    y_cont = rows(cont);
    x_cont_pad = padarray(x_cont,2000-length(x_cont),NaN,'post');
    y_cont_pad = padarray(y_cont,2000-length(y_cont),NaN,'post');
    ROIs_Contour_coords{i} = [x_cont_pad y_cont_pad];
end

nROIs = nROIs_outlines; % keep the number of ROIs after segmentation


if manual_ROI > 0
    Coords_outline = cell2mat(ROIs_Contour_coords);
    f = figure; f.Units = 'normalized'; f.Position = [0 0 1 1];
    imagesc(Ieq32); colormap gray; axis image; hold on
    scatter(Coords_outline(:,1:2:end),Coords_outline(:,2:2:end),20,'c','.');
answer = questdlg('Draw and add ROI manually?','Draw ROIs', ...
'No, neurons are found','Yes, I want to add ROI','Yes, I want to add ROI');
    switch answer
        case 'No, neurons are found'
            nROIs = nROIs_outlines; % keep the number of ROIs after segmentation
            close
        case 'Yes, I want to add ROI'
            P = 0;
            k = 1;
            while P == 0
                nROIs = nROIs_outlines + k;
                roi = drawassisted; % roi = drawcircle;
                roi_coords = round(roi.Position);
                x_cont = roi_coords(:,1);
                y_cont = roi_coords(:,2);
                x_cont_pad = padarray(x_cont,2000-length(x_cont),NaN,'post');
                y_cont_pad = padarray(y_cont,2000-length(y_cont),NaN,'post');
                ROIs_Contour_coords{nROIs} = [x_cont_pad y_cont_pad];

                    answer = questdlg('Finish adding ROIs?','Adding ROIs', ...
	                'No, I want to add more ROIs','Yes, finish adding ROIs','Yes, finish adding ROIs');
                    switch answer
                        case 'No, I want to add more ROIs'
                            P = 0;
                        case 'Yes, finish adding ROIs'
                            P = 1;
                            close
                    end
                 k = k + 1;
            end
    end
end

NSweeps = PARAMS(2).value;
Sweep_L = PARAMS(3).value;
Stack_filled = PARAMS(4).value;
Nframes_filled = PARAMS(1).value;
Size_I = size(Ieq32);

ROI_fullTraces_raw = zeros(Nframes_filled,nROIs);
ROI_fullTraces_den_Sym2 = zeros(Nframes_filled,nROIs);
ROIs_Roi_coords = cell(1,nROIs);
ROIs_Roi_center_coords = cell(1,nROIs);
 for i = 1:nROIs
    if i == round(nROIs*0.5)
        multiWaitbar('Segmentation,Trace Extraction...',0.5,'Color', [0.929 0.694 0.125]);
          elseif i == round(nROIs*0.8)
        multiWaitbar('Segmentation,Trace Extraction...',0.8,'Color', [0.929 0.694 0.125]);
          elseif i == nROIs
        multiWaitbar('Segmentation,Trace Extraction...',1,'Color', [0.929 0.694 0.125]);
    end

    % open up the already stored ROI contour coords
    Contour = cell2mat(ROIs_Contour_coords(i));
    nans = isnan(Contour(:,1)); Contour(nans,:) = [];
    x_cont = Contour(:,1);
    y_cont = Contour(:,2);

    
    Cent_x = round(mean(x_cont))-3; % -3 pixel for the ROI number
    Cent_y = round(mean(y_cont));
    ROIs_Roi_center_coords{i} = [Cent_x Cent_y];
    

    idx_cont = sub2ind(Size_I,y_cont,x_cont); % inpolygon needs idx

    in = inpolygon(rows,cols,rows(idx_cont),cols(idx_cont));
    idx_roi = find(in(:)); % roi pixel indices, including contour
    x_roi = cols(idx_roi);
    y_roi = rows(idx_roi);
    x_roi_pad = padarray(x_roi,2000-length(x_roi),NaN,'post');
    y_roi_pad = padarray(y_roi,2000-length(y_roi),NaN,'post');
    ROIs_Roi_coords{i} = [x_roi_pad y_roi_pad];

    npixel = numel(x_roi);
    trace_Roi_pixels = zeros(1,npixel,Nframes_filled);
    for j = 1:npixel
        x = x_roi(j,:);
        y = y_roi(j,:);
    trace_Roi_pixels(1,j,:) = Stack_filled(y,x,:);
    end
    Trace_ROI = squeeze(mean(trace_Roi_pixels,[1 2]));

    ROI_fullTraces_raw(:,i) = Trace_ROI;
    Trace_ROI_den = wdenoise(Trace_ROI,2,Wavelet='sym2',DenoisingMethod='Bayes');
    ROI_fullTraces_den_Sym2(:,i) = Trace_ROI_den;   
 end
    
 if discard_sweep > 0
    ROI_sweeps_raw = reshape(ROI_fullTraces_raw,Sweep_L,NSweeps*nROIs);
    ROI_sweeps_raw(:,discard_sweep:NSweeps:end) = [];
    NSweeps = NSweeps-1;
    PARAMS(2).value = NSweeps;
    ROI_fullTraces_raw = reshape(ROI_sweeps_raw,Sweep_L*NSweeps,nROIs);
    ROI_fullTraces_den_Sym2 = zeros(Sweep_L*NSweeps,nROIs);

    for i = 1:nROIs
        trace = ROI_fullTraces_raw(:,i);
        Trace_ROI_den = wdenoise(trace,2,Wavelet='sym2',DenoisingMethod='Bayes');
        ROI_fullTraces_den_Sym2(:,i) = Trace_ROI_den;
    end
 end


PARAMS(13).name = 'ROIs_shift_track';
PARAMS(14).name = 'ROI_fullTraces_raw';
PARAMS(15).name = 'ROI_fullTraces_den_Sym2';
PARAMS(16).name = 'nROIs';
PARAMS(17).name = 'ROIs_Contour_coords';
PARAMS(18).name = 'ROIs_Roi_coords';
PARAMS(19).name = 'ROIs_Roi_center_coords';


PARAMS(13).value = []; % labels that a video is FIRST
PARAMS(14).value = ROI_fullTraces_raw;
PARAMS(15).value = ROI_fullTraces_den_Sym2;
PARAMS(16).value = nROIs;
PARAMS(17).value = ROIs_Contour_coords;
PARAMS(18).value = ROIs_Roi_coords;
PARAMS(19).value = ROIs_Roi_center_coords;


PARAMS(4).name = [];
PARAMS(4).value = [];

end
