
function PARAMS = V_Stack_EQ_PAR(PARAMS)

Stack_filled = PARAMS(4).value;
Stack_AVG = mean(Stack_filled(:,:,5:100),3);
Size = size(Stack_AVG);
Stack_AVG = round(rescale(Stack_AVG,1,255)); % only works as now with (1,255)
Stack_AVG = double(Stack_AVG)/255;

windowsize = 30; % can be adjusted

Im_rim = zeros(Size(1)+(2*windowsize),Size(2)+(2*windowsize));
Im_rim(windowsize:size(Im_rim,1)-(windowsize+1),windowsize:size(Im_rim,2)-(windowsize+1)) = Stack_AVG;
%Orig_im_idx = find(Im_rim > 0);
Im = round(rescale(Im_rim,1,255)); % only works as now with (1,255)
Im = double(Im)/255;

Ieq = zeros(size(Im,1),size(Im,2));
n = floor(windowsize/2);
ImageSize = size(Im,1)-n;
for r = 1+n:ImageSize
    
        if r == round(ImageSize*0.05)
        multiWaitbar('Stack AVG Equalization...',0.05,'Color', [0.929 0.694 0.125]);
        elseif r == round(ImageSize*0.1)
        multiWaitbar('Stack AVG Equalization...',0.2,'Color', [0.929 0.694 0.125]);
        elseif r == round(ImageSize*0.3)
        multiWaitbar('Stack AVG Equalization...',0.4,'Color', [0.929 0.694 0.125]);
        elseif r == round(ImageSize*0.5)
        multiWaitbar('Stack AVG Equalization...',0.6,'Color', [0.929 0.694 0.125]);
        elseif r == round(ImageSize*0.8)
        multiWaitbar('Stack AVG Equalization...',0.8,'Color', [0.929 0.694 0.125]);
        elseif r == ImageSize
        multiWaitbar('Stack AVG Equalization...',1,'Color', [0.929 0.694 0.125]);
        end

  for c = 1+n:size(Im,2)-n

    if r-n <=1
      M_from = 1; M_to = r + n;
    else
      M_from = abs(r - n);
      if n + r >= size(Im,1)
        M_to = size(Im,1);
      else
        M_to = r + n;
      end
    end
    
    if c-n <= 1
      N_from = 1; N_to = c + n;
    else
      N_from = abs(c - n);
      if c + n > size(Im,2)
        N_to = size(Im,2);
      else
        N_to = c + n;
      end
    end
    
    neighbors = Im(M_from:M_to, N_from:N_to);
    counts = imhist(neighbors, 256);
    cdf = cumsum(counts);
    cdf = cdf ./ cdf(end);
    centerGrayLevel = Im(r, c);
    index = ceil(256 * centerGrayLevel);
    newPixelValue = cdf(index);
    Ieq(r,c) = newPixelValue;
    
  end
end
Ieq = Ieq(Im_rim > 0);
Ieq = reshape(Ieq,Size);
% Contrast enhance Ieq images
Ieq2 = Ieq .* Ieq;
Ieq4 = Ieq2 .* Ieq2;
Ieq8 = Ieq4 .* Ieq2;
Ieq16 = Ieq4 .* Ieq4;
Ieq32 = Ieq4 .* Ieq8;
Ieq64 = Ieq16 .* Ieq4;

PARAMS(5).name = 'Stack_AVG';
PARAMS(6).name = 'Ieq';
PARAMS(7).name = 'Ieq2';
PARAMS(8).name = 'Ieq4';
PARAMS(9).name = 'Ieq8';
PARAMS(10).name = 'Ieq16';
PARAMS(11).name = 'Ieq32';
PARAMS(12).name = 'Ieq64';

PARAMS(5).value = Stack_AVG;
PARAMS(6).value = Ieq;
PARAMS(7).value = Ieq2;
PARAMS(8).value = Ieq4;
PARAMS(9).value = Ieq8;
PARAMS(10).value = Ieq16;
PARAMS(11).value = Ieq32;
PARAMS(12).value = Ieq64;

end

