
function V_VoltView_PLOT_C(c,Suggest_ROI)

if c < 10 
  datafile1 = ['Data0000' num2str(c)];
elseif c > 9 && c < 100
  datafile1 = ['Data000' num2str(c)];
elseif c > 99
  datafile1 = ['Data00' num2str(c)];
end

filename1 = [datafile1 '.mat'];
C_PAR = struct2cell(load(filename1));
C_PAR = C_PAR{1};

DenRaw_sweeps_dff_poly2 = C_PAR(34).value;
NSweeps = C_PAR(2).value;
Sweep_L = C_PAR(3).value;
nROIs = double(C_PAR(16).value);
BlueSpike = C_PAR(21).value;
ROIs_Binary_BURST_Fix = C_PAR(48).value;
ROIs_AP_IDXs_MoveFilt = C_PAR(36).value;
ROIs_sweeps_DenRaw_dff_move_10 = C_PAR(32).value;
FovImage = C_PAR(5).value;
EQImage = C_PAR(11).value; % Ieq32
ROIs_Contour_coords = C_PAR(17).value;
ROIs_center_coords = C_PAR(19).value;
ROIs_Mean_Binary_PSPs_Pos = C_PAR(60).value;
ROIs_Mean_Binary_PSPs_Neg = C_PAR(61).value;
CORR_rank = C_PAR(64).value;
Cluster_colors = load('Cluster_colors.mat');
Cluster_colors = Cluster_colors.Cluster_colors;

%----------------------------------------------------------------------------
% VoltView - ROI Explorer

h = figure(1); h.Units = 'normalized'; h.Position = [0 0 1 1];
set(h, 'ToolBar', 'none');
set(h, 'MenuBar', 'none');
tg = uitabgroup(h);
pos0 = [0.085, 0.10, 0.85, 0.82];


Sub = 24;
nLoop = double(ceil(nROIs/Sub));
for v = 1:nLoop
ROI_Panel = ['ROI Panel ' num2str(v)];
tab = uitab(tg, 'title',ROI_Panel,'BackgroundColor','k');
tab_axes = axes('parent', tab);
hold(tab_axes,'on');
sgtitle('VoltView ROI Explorer 1.0','Color',[0.9290 0.6940 0.1250],'FontSize',20, ...
'HorizontalAlignment','left','FontAngle','italic');

g = subaxis(6,5,[1,2,3,6,7,8],'Spacing',0.02);
imagesc(FovImage); hold on
colormap gray;
axis image
%axes(g);
g.BoxStyle = 'full';
g.XColor = [0.9290 0.6940 0.1250];
g.YColor = [0.9290 0.6940 0.1250];
g.XTick = [];
g.YTick = [];
pos = g.Position;


for i = 1:nROIs
Cont = cell2mat(transpose(ROIs_Contour_coords(i)));
cent = cell2mat(ROIs_center_coords(i));
X = Cont(:,1); X(isnan(X)) = [];
Y = Cont(:,2); Y(isnan(Y)) = [];
    if isempty(Suggest_ROI) == 1
        Color = [0.8 0.8 0.8];
    elseif Suggest_ROI == 99
        sugg_cluster = CORR_rank(i);
        Color = Cluster_colors(sugg_cluster,:);
    elseif isempty(Suggest_ROI) == 0 & Suggest_ROI~=99
        user_def_idx = ismember(CORR_rank,Suggest_ROI);
        CORR_rank(~user_def_idx) = 0;
        if CORR_rank(i) == 0
            Color = [0.8 0.8 0.8];
        elseif CORR_rank(i) > 0
            sugg_cluster = CORR_rank(i);
            Color = Cluster_colors(sugg_cluster,:);
        end
    end
scatter(X,Y,3,Color,'filled');
Text = num2str(i);
text(cent(1), cent(2), Text,'Color','c','FontSize',9); % 'FontWeight','bold'
hold on
end



c = uicontrol('Parent',tab);
c.Units = 'normalized';
c.String = 'FLUO View';
c.Position = [0.020 0.86 0.06 0.07];
c.BackgroundColor = [0.9290 0.6940 0.1250];
c.FontSize = 10;
c.Callback = {@V_Fluo_C, g, FovImage, ROIs_Contour_coords, ROIs_center_coords,...
    CORR_rank, Cluster_colors, Suggest_ROI};

c = uicontrol('Parent',tab);
c.Units = 'normalized';
c.String = 'EQ View';
c.Position = [0.020 0.70 0.06 0.07];
c.BackgroundColor = [0.9290 0.6940 0.1250];
c.FontSize = 10;
c.Callback = {@V_EQ_C, g, EQImage, ROIs_Contour_coords, ROIs_center_coords,...
    CORR_rank, Cluster_colors, Suggest_ROI};

c = uicontrol('Parent',tab);
c.Units = 'normalized';
c.String = 'Cluster View';
c.Position = [0.020 0.78 0.06 0.07];
c.BackgroundColor = [0.9290 0.6940 0.1250];
c.FontSize = 10;
c.Callback = {@V_Cluster_ID_C, g, FovImage, ROIs_Contour_coords, ROIs_center_coords,...
    CORR_rank, Cluster_colors, Suggest_ROI};

c = uicontrol('Parent',tab);
c.Units = 'normalized';
c.String = 'FOV Zoom';
c.Position = [0.020 0.62 0.06 0.07];
c.BackgroundColor = [0.9290 0.6940 0.1250];
c.FontSize = 10;
c.Callback = {@V_FOV_Zoom, g, pos, pos0};
%-----------------------------------------------------


        if v == 1
            Tags = (1:24);
            from = 1;
            if nROIs < Sub
              to = nROIs;
            else
              to = Sub;
            end
        else
            Tags = (((v-1)*Sub)+1:((v-1)*Sub)+24);
            from = ((v-1)*Sub)+1;
            if nROIs < v*Sub
              to = nROIs;  
            else
              to = v*Sub;
            end
        end


 Sub_idx = [4,5,9,(10:30)];
 k = 1;
 for i = from:to
    roi_co1_idx = ((i*NSweeps+1)-NSweeps : i*NSweeps);
    ROI_sweeps_dff = DenRaw_sweeps_dff_poly2(:,roi_co1_idx);
    sweeps_half_max = (max(max(ROI_sweeps_dff)))/2;
    sweeps_dist = (max(max(ROI_sweeps_dff)) + abs(min(min(ROI_sweeps_dff)))/4);
    ROI_sweeps_dff_move_10 = ROIs_sweeps_DenRaw_dff_move_10(:,roi_co1_idx);
    Mean_sweep = mean(ROI_sweeps_dff,2);
    Mean_sweep_move = mean(ROI_sweeps_dff_move_10,2);
    max_ylim = sweeps_dist*(NSweeps+2);
    sweep_zero(1:length(ROI_sweeps_dff)) = 0;
    %--------------------------------------------------------------
    ROI_BB_fix = cell2mat(ROIs_Binary_BURST_Fix(i,1));
    ROI_BB_fix(ROI_BB_fix == 0) = NaN;
    ROI_BB_fix(ROI_BB_fix == 1) = 0;
    
    ROI_ap_above = cell2mat(ROIs_AP_IDXs_MoveFilt(i,1));

    Mean_PSP_POS = cell2mat(ROIs_Mean_Binary_PSPs_Pos(i));
    Mean_PSP_POS(Mean_PSP_POS == 1) = sweeps_half_max;

    Mean_PSP_NEG = cell2mat(ROIs_Mean_Binary_PSPs_Neg(i));
    Mean_PSP_NEG(Mean_PSP_NEG == 1) = sweeps_half_max*-1;
    %-----------------------------------------------------------

        g = subaxis(6,5,Sub_idx(k),'Spacing',0.02);
    for j = 1:NSweeps
        sweep_zero_s = sweep_zero + (sweeps_dist*(j));
        sweep_denraw_s = ROI_sweeps_dff(:,j) + (sweeps_dist*(j));
        sweep_move_10_s = ROI_sweeps_dff_move_10(:,j) + (sweeps_dist*(j));
        binary_burst_fix_s = ROI_BB_fix(:,j) + (sweeps_dist*(j));
        APs_ab = ROI_ap_above(:,j); APs_ab(isnan(APs_ab)) = [];
           
        scatter(APs_ab,sweep_denraw_s(APs_ab),20,'m','filled');         hold on
        plot(sweep_zero_s,'Color','w','LineWidth',0.2);                 hold on
        plot(sweep_denraw_s,'Color',[0.96, 0.74, 0.12],'LineWidth',1);  hold on
        plot(sweep_move_10_s,'Color','g','LineWidth',0.75);             hold on
        plot(binary_burst_fix_s,'Color','w','LineWidth',4);             hold on
     end
    
    hold on
    plot(Mean_sweep,'Color',[0.96, 0.74, 0.12],'LineWidth',2);          hold on
    plot(Mean_sweep_move,'Color','g','LineWidth',2);                    hold on
    plot(Mean_PSP_POS,'Color','c','LineWidth',0.75);                    hold on
    plot(Mean_PSP_NEG,'Color','y','LineWidth',0.75);                    hold on
    for l = 1:numel(BlueSpike)
        line([BlueSpike(l) BlueSpike(l)],[sweeps_half_max (max_ylim - sweeps_dist)],'Color','c','LineWidth',0.3);
    end

    axis([10,Sweep_L,0-sweeps_dist,max_ylim]);
    line([Sweep_L*0.9 Sweep_L],[max_ylim max_ylim],'Color','c','LineWidth',0.5);
    line([Sweep_L*0.9 Sweep_L],[max_ylim*0.89 max_ylim*0.89],'Color','c','LineWidth',0.5);
    line([Sweep_L*0.9 Sweep_L*0.9],[max_ylim max_ylim*0.89],'Color','c','LineWidth',0.5);
    line([Sweep_L Sweep_L],[max_ylim max_ylim*0.89],'Color','c','LineWidth',0.5);


    pos = g.Position;
    set(gca,'tag',num2str(Tags(k)));
    set(g, 'buttondownfcn', {@V_ROI_Zoom_C, g, pos, pos0, FovImage, ROIs_Contour_coords,...
        ROIs_center_coords, CORR_rank, Cluster_colors, Suggest_ROI});
    set(gca,'color','k');
    g.XTick = [];
    g.YTick = [];
    g.BoxStyle = 'full';
    g.XColor = 'k';
    g.YColor = 'k';
    caption = sprintf('ROI #%d', Tags(k)); 
    title(caption,'FontSize',8,'color','c');
    k = k + 1;
 end

end

end
