
function V_VoltView_PLOT_SUB_test(PARAMS)

NSweeps = PARAMS(2).value;
Sweep_L = PARAMS(3).value;
nROIs = double(PARAMS(16).value);
BlueSpike = PARAMS(21).value;
DenRaw_sweeps_dff_poly2 = PARAMS(34).value;
ROIs_Binary_BURST_Fix = PARAMS(48).value;
ROIs_AP_IDXs_MoveFilt = PARAMS(36).value;
ROIs_sweeps_DenRaw_dff_move_10 = PARAMS(32).value;
ROIs_Stim_Binary_PSPs_Pos = PARAMS(56).value;
ROIs_Stim_Binary_PSPs_Neg = PARAMS(57).value;
ROIs_Mean_Binary_PSPs_Pos = PARAMS(60).value;
ROIs_Mean_Binary_PSPs_Neg = PARAMS(61).value;

%----------------------------------------------------------------------------
% VoltView - ROI Explorer

h = figure(1); h.Units = 'normalized'; h.Position = [0 0 1 1];
%set(h, 'ToolBar', 'none');
%set(h, 'MenuBar', 'none');
tg = uitabgroup(h);
pos0 = [0.085, 0.10, 0.85, 0.82];


Sub = 30;
nLoop = ceil(nROIs/Sub);

for v = 1:nLoop
    ROI_Panel = ['Panel ' num2str(v)];
    tab = uitab(tg, 'title',ROI_Panel,'BackgroundColor','k');
    tab_axes = axes('parent', tab);
    hold(tab_axes,'on');
    sgtitle('VoltView - ROI Browser','Color',[0.9290 0.6940 0.1250],'FontSize',20, ...
    'HorizontalAlignment','left');

        if v == 1
            Tags = (1:Sub);
            from = 1;
            if nROIs < Sub
              to = nROIs;
            else
              to = Sub;
            end
        else
            Tags = (((v-1)*Sub)+1:((v-1)*Sub)+Sub);
            from = ((v-1)*Sub)+1;
            if nROIs < v*Sub
              to = nROIs;  
            else
              to = v*Sub;
            end
        end

 Sub_idx = (1:30);
 k = 1;
 for i = from:to
    roi_co1_idx = ((i*NSweeps+1)-NSweeps : i*NSweeps);
    ROI_sweeps_dff = DenRaw_sweeps_dff_poly2(:,roi_co1_idx);
    ROI_sweeps_dff_move_10 = ROIs_sweeps_DenRaw_dff_move_10(:,roi_co1_idx);
    Mean_sweep = mean(ROI_sweeps_dff,2);
    Mean_sweep_move = mean(ROI_sweeps_dff_move_10,2);
    sweeps_half_max = (max(max(ROI_sweeps_dff)))/2;
    sweeps_dist = (max(max(ROI_sweeps_dff)) + abs(min(min(ROI_sweeps_dff)))/2);
    max_ylim = sweeps_dist*(NSweeps+1);
        if isempty(ROI_sweeps_dff(~isnan(ROI_sweeps_dff))) == 1
                ROI_sweeps_dff(1:Sweep_L,:) = 0;
                ROI_sweeps_dff_move_10(1:Sweep_L,:) = 0;
                Mean_sweep(1:Sweep_L,:) = 0;
                Mean_sweep_move(1:Sweep_L,:) = 0;
                sweeps_half_max = 0.005;
                sweeps_dist = 0.01;
                max_ylim = sweeps_dist*(NSweeps+1);
        end
    sweep_zero(1:length(ROI_sweeps_dff)) = 0;
    %--------------------------------------------------------------
    % make different sweep lengths and sweep numbers uniform across animals
    ROI_BB_fix = cell2mat(ROIs_Binary_BURST_Fix(i));
    if size(ROI_BB_fix,1) < 1435
        miss = 1435 - size(ROI_BB_fix,1);
        ROI_BB_fix(end+1:end+miss,:) = zeros(miss,size(ROI_BB_fix,2));
    end
    if size(ROI_BB_fix,2) < 7
        miss = 7 - size(ROI_BB_fix,2);
        ROI_BB_fix(:,end+1:end+miss) = ROI_BB_fix(:,end);
    end
        
    ROI_BB_fix(ROI_BB_fix == 0) = NaN;
    ROI_BB_fix(ROI_BB_fix == 1) = 0;
    
    
    ROI_ap_above = cell2mat(ROIs_AP_IDXs_MoveFilt(i));
    if size(ROI_ap_above,2) < 7
        miss = 7 - size(ROI_ap_above,2);
        ROI_ap_above(:,end+1:end+miss) = ROI_ap_above(:,end);
    end


    PSP_POS = cell2mat(ROIs_Stim_Binary_PSPs_Pos(i));
    PSP_POS(PSP_POS == 1) = sweeps_half_max;

    PSP_NEG = cell2mat(ROIs_Stim_Binary_PSPs_Neg(i));
    PSP_NEG(PSP_NEG == -1) = sweeps_half_max*-1;

    Mean_PSP_POS = cell2mat(ROIs_Mean_Binary_PSPs_Pos(i));
    Mean_PSP_POS(Mean_PSP_POS == 1) = sweeps_half_max;

    Mean_PSP_NEG = cell2mat(ROIs_Mean_Binary_PSPs_Neg(i));
    Mean_PSP_NEG(Mean_PSP_NEG == 1) = sweeps_half_max*-1;
    
    %-----------------------------------------------------------

        g = subaxis(6,5,Sub_idx(k),'Spacing',0.02);
    for j = 1:NSweeps
        sweep_zero_s = sweep_zero + (sweeps_dist*(j));
        sweep_denraw_s = ROI_sweeps_dff(:,j) + (sweeps_dist*(j));
        sweep_move_10_s = ROI_sweeps_dff_move_10(:,j) + (sweeps_dist*(j));
        binary_burst_fix_s = ROI_BB_fix(:,j) + (sweeps_dist*(j));
        APs_ab = ROI_ap_above(:,j); APs_ab(isnan(APs_ab)) = [];
        binary_psp_Pos_s = PSP_POS(:,j) + (sweeps_dist*(j));
        binary_psp_Neg_s = PSP_NEG(:,j) + (sweeps_dist*(j));
           
        scatter(APs_ab,sweep_denraw_s(APs_ab),20,'m','filled');        hold on
        plot(sweep_denraw_s,'Color',[0.96, 0.74, 0.12],'LineWidth',1); hold on
        plot(sweep_move_10_s,'Color','g','LineWidth',0.75);            hold on
        plot(binary_burst_fix_s,'Color','w','LineWidth',4);            hold on

        plot(binary_psp_Pos_s,'Color','c','LineWidth',0.75);           hold on
        plot(binary_psp_Neg_s,'Color','y','LineWidth',0.75);           hold on
        plot(sweep_zero_s,'Color','w','LineWidth',0.2);                hold on
     end
    
    hold on
    plot(Mean_sweep,'Color',[0.96, 0.74, 0.12],'LineWidth',2);         hold on
    plot(Mean_sweep_move,'Color','g','LineWidth',2);                   hold on
    plot(Mean_PSP_POS,'Color','c','LineWidth',0.75);                   hold on
    plot(Mean_PSP_NEG,'Color','y','LineWidth',0.75);                   hold on
    for l = 1:numel(BlueSpike)
    line([BlueSpike(l) BlueSpike(l)],[sweeps_half_max max_ylim],'Color','c','LineWidth',0.3);
    end

    axis([10,Sweep_L,0-sweeps_dist,max_ylim]);
    pos = g.Position;
    set(gca,'tag',num2str(Tags(k)));
    set(g, 'buttondownfcn', {@V_ROI_Zoom_Cell_Type, g, pos, pos0});
    set(gca,'color','k');
    g.XTick = [];
    g.YTick = [];
    g.BoxStyle = 'full';
    g.XColor = 'k'; %[0.9290 0.6940 0.1250];
    g.YColor = 'k'; %[0.9290 0.6940 0.1250];
    caption = sprintf('ROI #%d', Tags(k));
    title(caption,'color','c'); % [0.9290 0.6940 0.1250]
    k = k + 1;
 end

end

end
